diff --git a/product/features/com.jboss.jbds.product.extra.feature/feature.xml b/product/features/com.jboss.jbds.product.extra.feature/feature.xml
index 8764bc1..7686e5d 100644
--- a/product/features/com.jboss.jbds.product.extra.feature/feature.xml
+++ b/product/features/com.jboss.jbds.product.extra.feature/feature.xml
@@ -2,7 +2,7 @@
 <feature
       id="com.jboss.jbds.product.extra.feature"
       label="%featureName"
-      version="1.0.0.qualifier"
+      version="1.0.1.qualifier"
       provider-name="%providerName"
       >
 
@@ -23,8 +23,8 @@
    </url>
 
    <requires>
-      <import feature="com.jboss.jbds.springide.feature" version="1.0.0.qualifier" match="compatible"/>
-      <import feature="com.jboss.jbds.testng.feature" version="1.0.0.qualifier" match="compatible"/>
+      <import feature="com.jboss.jbds.springide.feature" version="1.0.1.qualifier" match="compatible"/>
+      <import feature="com.jboss.jbds.testng.feature" version="1.0.1.qualifier" match="compatible"/>
    </requires>
 
 </feature>
diff --git a/product/features/com.jboss.jbds.product.extra.feature/pom.xml b/product/features/com.jboss.jbds.product.extra.feature/pom.xml
index 9b49d5d..1c7109d 100644
--- a/product/features/com.jboss.jbds.product.extra.feature/pom.xml
+++ b/product/features/com.jboss.jbds.product.extra.feature/pom.xml
@@ -9,7 +9,7 @@
 	</parent>
 	<groupId>com.jboss.jbds.product.features</groupId>
 	<artifactId>com.jboss.jbds.product.extra.feature</artifactId>
-	<version>1.0.0-SNAPSHOT</version>
+	<version>1.0.1-SNAPSHOT</version>
 	<packaging>eclipse-feature</packaging>
 
 	<repositories>
diff --git a/product/features/com.jboss.jbds.product.feature/feature.xml b/product/features/com.jboss.jbds.product.feature/feature.xml
index d59780a..fe59462 100644
--- a/product/features/com.jboss.jbds.product.feature/feature.xml
+++ b/product/features/com.jboss.jbds.product.feature/feature.xml
@@ -2,7 +2,7 @@
 <feature
       id="com.jboss.jbds.product.feature"
       label="%featureName"
-      version="4.0.0.qualifier"
+      version="4.0.1.qualifier"
       provider-name="%providerName"
       plugin="com.jboss.jbds.product">
 
diff --git a/product/features/com.jboss.jbds.product.feature/pom.xml b/product/features/com.jboss.jbds.product.feature/pom.xml
index 47a0790..936f4bf 100644
--- a/product/features/com.jboss.jbds.product.feature/pom.xml
+++ b/product/features/com.jboss.jbds.product.feature/pom.xml
@@ -9,7 +9,7 @@
 	</parent>
 	<groupId>com.jboss.jbds.product.features</groupId>
 	<artifactId>com.jboss.jbds.product.feature</artifactId>
-	<version>4.0.0-SNAPSHOT</version>
+	<version>4.0.1-SNAPSHOT</version>
 	<packaging>eclipse-feature</packaging>
 
 </project>
diff --git a/product/features/com.jboss.jbds.springide.feature/feature.xml b/product/features/com.jboss.jbds.springide.feature/feature.xml
index 51d84c9..ff8991f 100644
--- a/product/features/com.jboss.jbds.springide.feature/feature.xml
+++ b/product/features/com.jboss.jbds.springide.feature/feature.xml
@@ -2,7 +2,7 @@
 <feature
       id="com.jboss.jbds.springide.feature"
       label="Spring IDE (Certified)"
-      version="1.0.0.qualifier"
+      version="1.0.1.qualifier"
       provider-name="JBoss by RedHat">
 
    <description>
diff --git a/product/features/com.jboss.jbds.springide.feature/pom.xml b/product/features/com.jboss.jbds.springide.feature/pom.xml
index 9eb1613..0d87b61 100644
--- a/product/features/com.jboss.jbds.springide.feature/pom.xml
+++ b/product/features/com.jboss.jbds.springide.feature/pom.xml
@@ -9,7 +9,7 @@
 	</parent>
 	<groupId>com.jboss.jbds.product.features</groupId>
 	<artifactId>com.jboss.jbds.springide.feature</artifactId>
-	<version>1.0.0-SNAPSHOT</version>
+	<version>1.0.1-SNAPSHOT</version>
 	<packaging>eclipse-feature</packaging>
 
 
diff --git a/product/features/com.jboss.jbds.testng.feature/feature.xml b/product/features/com.jboss.jbds.testng.feature/feature.xml
index 31c55b6..d2e6283 100644
--- a/product/features/com.jboss.jbds.testng.feature/feature.xml
+++ b/product/features/com.jboss.jbds.testng.feature/feature.xml
@@ -2,7 +2,7 @@
 <feature
       id="com.jboss.jbds.testng.feature"
       label="TestNG (Certified)"
-      version="1.0.0.qualifier"
+      version="1.0.1.qualifier"
       provider-name="JBoss by Red Hat">
 
    <description>
diff --git a/product/features/com.jboss.jbds.testng.feature/pom.xml b/product/features/com.jboss.jbds.testng.feature/pom.xml
index 821c720..c1be668 100644
--- a/product/features/com.jboss.jbds.testng.feature/pom.xml
+++ b/product/features/com.jboss.jbds.testng.feature/pom.xml
@@ -9,7 +9,7 @@
 	</parent>
 	<groupId>com.jboss.jbds.product.features</groupId>
 	<artifactId>com.jboss.jbds.testng.feature</artifactId>
-	<version>1.0.0-SNAPSHOT</version>
+	<version>1.0.1-SNAPSHOT</version>
 	<packaging>eclipse-feature</packaging>
 
 	<repositories>
diff --git a/product/features/com.jboss.jbds/com.jboss.jbds.product b/product/features/com.jboss.jbds/com.jboss.jbds.product
index fa41a42..cde37b7 100644
--- a/product/features/com.jboss.jbds/com.jboss.jbds.product
+++ b/product/features/com.jboss.jbds/com.jboss.jbds.product
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <?pde version="3.5"?>
 
-<product name="JBoss Developer Studio for Web and SOA Development" uid="com.jboss.jbds.all" id="com.jboss.jbds.product.product" application="org.eclipse.ui.ide.workbench" version="4.0.0.qualifier" useFeatures="true" includeLaunchers="true">
+<product name="JBoss Developer Studio for Web and SOA Development" uid="com.jboss.jbds.all" id="com.jboss.jbds.product.product" application="org.eclipse.ui.ide.workbench" version="4.0.1.qualifier" useFeatures="true" includeLaunchers="true">
 
    <configIni use="default">
    </configIni>
@@ -40,7 +40,7 @@ openFile</programArgs>
    </plugins>
 
    <features>
-      <feature id="com.jboss.jbds.product.feature" version="4.0.0.qualifier"/>
+      <feature id="com.jboss.jbds.product.feature" version="4.0.1.qualifier"/>
    </features>
 
    <configurations>
diff --git a/product/features/com.jboss.jbds/pom.xml b/product/features/com.jboss.jbds/pom.xml
index 435cd2b..159ee88 100644
--- a/product/features/com.jboss.jbds/pom.xml
+++ b/product/features/com.jboss.jbds/pom.xml
@@ -9,7 +9,7 @@
 	</parent>
 	<groupId>com.jboss.jbds.product.features</groupId>
 	<artifactId>com.jboss.jbds</artifactId>
-	<version>4.0.0-SNAPSHOT</version>
+	<version>4.0.1-SNAPSHOT</version>
 	<packaging>eclipse-repository</packaging>
 	<build>
 		<plugins>