Index: as/plugins/org.jboss.ide.eclipse.as.rse.ui/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.rse.ui/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.rse.ui/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.rse.ui</artifactId> 
 	<version>0.9.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.management.as7/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.management.as7/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.management.as7/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.management.as7</artifactId> 
Index: as/plugins/org.jboss.ide.eclipse.as.wtp.ui/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.wtp.ui/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.wtp.ui/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.wtp.ui</artifactId> 
 	<version>2.2.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.core/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.core/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.core/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.core</artifactId> 
 	<version>2.2.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.classpath.core/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.classpath.core/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.classpath.core/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.classpath.core</artifactId> 
 	<version>2.2.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.ui/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.ui/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.ui/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.ui</artifactId> 
 	<version>2.2.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.classpath.ui/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.classpath.ui/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.classpath.ui/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.classpath.ui</artifactId> 
 	<version>2.1.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.archives.webtools/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.archives.webtools/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.archives.webtools/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.archives.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.archives.webtools</artifactId> 
 	<version>2.2.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/pom.xml
===================================================================
--- as/plugins/pom.xml	(revision 31251)
+++ as/plugins/pom.xml	(working copy)
@@ -1,6 +1,11 @@
 <project
 xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd" xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 	<modelVersion>4.0.0</modelVersion>
+	<parent>
+		<groupId>org.jboss.tools</groupId>
+		<artifactId>as</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
+	</parent>
 	<groupId>org.jboss.tools.as</groupId>
 	<artifactId>plugins</artifactId>
 	<version>0.0.1-SNAPSHOT</version>
Index: as/plugins/org.jboss.ide.eclipse.as.rse.core/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.rse.core/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.rse.core/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.rse.core</artifactId> 
 	<version>0.9.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.jmx.integration/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.jmx.integration/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.jmx.integration/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.jmx.integration</artifactId> 
 	<version>0.9.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.ui.mbeans/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.ui.mbeans/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.ui.mbeans/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.ui.mbeans</artifactId> 
 	<version>2.1.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.wtp.core/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.wtp.core/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.wtp.core/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.plugins</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.wtp.core</artifactId> 
 	<version>2.2.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/plugins/org.jboss.ide.eclipse.as.doc.user/pom.xml
===================================================================
--- as/plugins/org.jboss.ide.eclipse.as.doc.user/pom.xml	(revision 31251)
+++ as/plugins/org.jboss.ide.eclipse.as.doc.user/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>plugins</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.docs</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.doc.user</artifactId> 
 	<version>2.1.0-SNAPSHOT</version>
 	<packaging>eclipse-plugin</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/tests/org.jboss.ide.eclipse.as.ui.test/pom.xml
===================================================================
--- as/tests/org.jboss.ide.eclipse.as.ui.test/pom.xml	(revision 31251)
+++ as/tests/org.jboss.ide.eclipse.as.ui.test/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>tests</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.tests</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.ui.test</artifactId> 
@@ -30,4 +30,4 @@
 			</plugin>
 		</plugins>
 	</build>
-</project>
\ No newline at end of file
+</project>
Index: as/tests/org.jboss.ide.eclipse.as.test/pom.xml
===================================================================
--- as/tests/org.jboss.ide.eclipse.as.test/pom.xml	(revision 31251)
+++ as/tests/org.jboss.ide.eclipse.as.test/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>tests</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.tests</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.test</artifactId> 
Index: as/tests/pom.xml
===================================================================
--- as/tests/pom.xml	(revision 31251)
+++ as/tests/pom.xml	(working copy)
@@ -1,6 +1,11 @@
 <project
 xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd" xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 	<modelVersion>4.0.0</modelVersion>
+	<parent>
+		<groupId>org.jboss.tools</groupId>
+		<artifactId>as</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
+	</parent>
 	<groupId>org.jboss.tools.as</groupId>
 	<artifactId>tests</artifactId>
 	<name>as.tests</name>
Index: as/tests/org.jboss.ide.eclipse.as.archives.integration.test/pom.xml
===================================================================
--- as/tests/org.jboss.ide.eclipse.as.archives.integration.test/pom.xml	(revision 31251)
+++ as/tests/org.jboss.ide.eclipse.as.archives.integration.test/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>tests</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.tests</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.archives.integration.test</artifactId> 
@@ -17,4 +17,4 @@
 	</properties>
 
 	
-</project>
\ No newline at end of file
+</project>
Index: as/site/pom.xml
===================================================================
--- as/site/pom.xml	(revision 31251)
+++ as/site/pom.xml	(working copy)
@@ -2,14 +2,13 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-		
 		<groupId>org.jboss.tools</groupId>
-		<artifactId>org.jboss.tools.parent.pom</artifactId>
-		<version>0.0.2-SNAPSHOT</version>
+		<artifactId>as</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as</groupId>
 	<artifactId>as.site</artifactId> 
 	<name>as.site</name>
 	<version>0.0.1-SNAPSHOT</version>
 	<packaging>eclipse-update-site</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/pom.xml
===================================================================
--- as/pom.xml	(revision 31251)
+++ as/pom.xml	(working copy)
@@ -1,6 +1,12 @@
 <project
 xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd" xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 	<modelVersion>4.0.0</modelVersion>
+	<parent>
+		<groupId>org.jboss.tools</groupId>
+		<artifactId>org.jboss.tools.parent.pom</artifactId>
+		<version>0.0.2-SNAPSHOT</version>
+		<relativePath>../build/parent/pom.xml</relativePath>
+	</parent>
 	<groupId>org.jboss.tools</groupId>
 	<artifactId>as</artifactId>
 	<name>as.all</name>
Index: as/features/org.jboss.ide.eclipse.as.test.feature/pom.xml
===================================================================
--- as/features/org.jboss.ide.eclipse.as.test.feature/pom.xml	(revision 31251)
+++ as/features/org.jboss.ide.eclipse.as.test.feature/pom.xml	(working copy)
@@ -2,12 +2,12 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>features</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.features</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.test.feature</artifactId> 
 	<version>2.1.0-SNAPSHOT</version>
 	<packaging>eclipse-feature</packaging>
-</project>
\ No newline at end of file
+</project>
Index: as/features/org.jboss.ide.eclipse.as.jmx.integration.feature/pom.xml
===================================================================
--- as/features/org.jboss.ide.eclipse.as.jmx.integration.feature/pom.xml	(revision 31251)
+++ as/features/org.jboss.ide.eclipse.as.jmx.integration.feature/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>features</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.features</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.jmx.integration.feature</artifactId> 
Index: as/features/org.jboss.ide.eclipse.as.server.rse.integration.feature/pom.xml
===================================================================
--- as/features/org.jboss.ide.eclipse.as.server.rse.integration.feature/pom.xml	(revision 31251)
+++ as/features/org.jboss.ide.eclipse.as.server.rse.integration.feature/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>features</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.features</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.server.rse.integration.feature</artifactId> 
Index: as/features/org.jboss.ide.eclipse.as.serverAdapter.wtp.feature/pom.xml
===================================================================
--- as/features/org.jboss.ide.eclipse.as.serverAdapter.wtp.feature/pom.xml	(revision 31251)
+++ as/features/org.jboss.ide.eclipse.as.serverAdapter.wtp.feature/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>features</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.features</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.serverAdapter.wtp.feature</artifactId> 
Index: as/features/org.jboss.ide.eclipse.as.feature/pom.xml
===================================================================
--- as/features/org.jboss.ide.eclipse.as.feature/pom.xml	(revision 31251)
+++ as/features/org.jboss.ide.eclipse.as.feature/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>features</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.features</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.feature</artifactId> 
Index: as/features/pom.xml
===================================================================
--- as/features/pom.xml	(revision 31251)
+++ as/features/pom.xml	(working copy)
@@ -1,6 +1,11 @@
 <project
 xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd" xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
 	<modelVersion>4.0.0</modelVersion>
+	<parent>
+		<groupId>org.jboss.tools</groupId>
+		<artifactId>as</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
+	</parent>
 	<groupId>org.jboss.tools.as</groupId>
 	<artifactId>features</artifactId>
 	<version>0.0.1-SNAPSHOT</version>
Index: as/features/org.jboss.ide.eclipse.as.archives.integration.feature/pom.xml
===================================================================
--- as/features/org.jboss.ide.eclipse.as.archives.integration.feature/pom.xml	(revision 31251)
+++ as/features/org.jboss.ide.eclipse.as.archives.integration.feature/pom.xml	(working copy)
@@ -2,9 +2,9 @@
 <project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
 	<modelVersion>4.0.0</modelVersion> 
 	<parent>
-	  <groupId>org.jboss.tools</groupId>
-	  <artifactId>org.jboss.tools.parent.pom</artifactId>
-	  <version>0.0.2-SNAPSHOT</version>
+		<groupId>org.jboss.tools.as</groupId>
+		<artifactId>features</artifactId>
+		<version>0.0.1-SNAPSHOT</version>
 	</parent>
 	<groupId>org.jboss.tools.as.features</groupId>
 	<artifactId>org.jboss.ide.eclipse.as.archives.integration.feature</artifactId> 